cordova.define('cordova/plugin_list', function(require, exports, module) {
module.exports = [

  {
      "file": "plugins/org.apache.cordova.media/www/MediaError.js",
      "id": "org.apache.cordova.media.MediaError",
      "clobbers": [
          "window.MediaError"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.media/www/Media.js",
      "id": "org.apache.cordova.media.Media",
      "clobbers": [
          "window.Media"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.device/www/device.js",
      "id": "org.apache.cordova.device.device",
      "clobbers": [
          "device"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.vibration/www/vibration.js",
      "id": "org.apache.cordova.vibration.notification",
      "merges": [
          "navigator.notification"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.dialogs/www/notification.js",
      "id": "org.apache.cordova.dialogs.notification",
      "merges": [
          "navigator.notification"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.dialogs/www/android/notification.js",
      "id": "org.apache.cordova.dialogs.notification_android",
      "merges": [
          "navigator.notification"
      ]
  },
  {
      "file": "plugins/nl.x-services.plugins.socialsharing/www/SocialSharing.js",
      "id": "nl.x-services.plugins.socialsharing.SocialSharing",
      "clobbers": [
          "window.plugins.socialsharing"
      ]
  },
  {
      "file": "plugins/com.phonegap.plugins.Version/www/version.js",
      "id": "com.phonegap.plugins.Version.Version",
      "clobbers": [
          "window.plugins.version"
      ]
  },
  {
      "file": "plugins/com.phonegap.plugins.speech.TTS/www/tts.js",
      "id": "com.phonegap.plugins.speech.TTS.TTS",
      "clobbers": [
          "window.plugins.tts"
      ]
  },
  {
      "file": "plugins/com.phonegap.plugins.nativeFunctionCall/www/customNativeAccess.js",
      "id": "com.phonegap.plugins.nativeFunctionCall.CustomNativeAccess",
      "clobbers": [
          "nativeFunctionCall"
      ]
  },
  {
      "file": "plugins/com.phonegap.plugins.VolumeControl/www/VolumeControl.js",
      "id": "com.phonegap.plugins.VolumeControl.VolumeControl",
      "clobbers": [
          "VolumeControl"
      ]
  },
  {
      "file": "plugins/com.phonegap.plugins.toastMessage/www/toastMessage.js",
      "id": "com.phonegap.plugins.toastMessage.Toasts",
      "clobbers": [
          "toasts"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.globalization/www/GlobalizationError.js",
      "id": "org.apache.cordova.globalization.GlobalizationError",
      "clobbers": [
          "window.GlobalizationError"
      ]
  },
  {
      "file": "plugins/org.apache.cordova.globalization/www/globalization.js",
      "id": "org.apache.cordova.globalization.globalization",
      "clobbers": [
          "navigator.globalization"
      ]
  },
  {
      "file": "plugins/com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice.sample/www/myService.js",
      "id": "com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice.sample.MyService",
      "clobbers": [
          "cordova.plugins.myService"
      ]
  },
  {
      "file": "plugins/com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice/www/backgroundService.js",
      "id": "com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice.BackgroundService"
  },
  {
          "file": "plugins/cordova-plugin-network-information/www/network.js",
          "id": "cordova-plugin-network-information.network",
          "clobbers": [
              "navigator.connection",
              "navigator.network.connection"
       ]
  },
  {
          "file": "plugins/cordova-plugin-network-information/www/Connection.js",
          "id": "cordova-plugin-network-information.Connection",
          "clobbers": [
              "Connection"
       ]
  },
  {
      "file": "plugins/nl.x-services.plugins.insomnia/www/Insomnia.js",
      "id": "nl.x-services.plugins.insomnia.Insomnia",
      "clobbers": [
          "window.plugins.insomnia"
      ]
  },
  {
      "file": "plugins/com.rhythmicworks.phonegap.plugin.analytics/www/analytics.js",
      "id": "com.rhythmicworks.phonegap.plugin.analytics.UniversalAnalyticsPlugin",
      "clobbers": [
          "window.plugins.analytics"
      ]
  },
  {
          "file": "plugins/com.rhythmicworks.phonegap.plugin.sharedPreferences/www/sharedprefs.js",
          "id": "com.rhythmicworks.phonegap.plugin.sharedPreferences.SharedPrefs",
          "clobbers": [
              "window.plugins.sharedPrefs"
          ]
  },
  {
      "file": "plugins/cordova-plugin-inappbrowser/www/inappbrowser.js",
      "id": "cordova-plugin-inappbrowser.inappbrowser",
      "clobbers": [
          "cordova.InAppBrowser.open",
          "window.open"
      ]
  },
  {
            "file": "plugins/cordova-plugin-splashscreen/www/splashscreen.js",
            "id": "cordova-plugin-splashscreen.SplashScreen",
            "clobbers": [
                "navigator.splashscreen"
            ]
  },

  {
         "file": "plugins/cordova-plugin-whitelist/whitelist.js",
         "id": "cordova-plugin-whitelist.whitelist",
         "runs": true
  },

//  AdMob for Free
    {
        "file": "plugins/cordova-admob/www/admob.js",
        "id": "cordova-admob.AdMobAds",
        "clobbers": [
            "window.admob",
            "window.tappx"
        ]
    },
    {
        "file": "plugins/cordova-connectivity-monitor/www/connectivity.js",
        "id": "cordova-connectivity-monitor.connectivity",
        "clobbers": [
            "window.connectivity"
        ]
    }
];
module.exports.metadata =
// TOP OF METADATA
{
  "org.apache.cordova.media": "0.2.6",
  "org.apache.cordova.device": "0.2.5",
  "org.apache.cordova.vibration": "0.3.5",
  "org.apache.cordova.dialogs": "0.2.4",
  "nl.x-services.plugins.socialsharing": "3.5",
  "com.adobe.plugins.GAPlugin": "2.3.1",
  "com.phonegap.plugins.Version": "1.0",
  "com.phonegap.plugins.speech.TTS": "2.2.1",
  "com.phonegap.plugins.nativeFunctionCall": "1.0",
  "com.phonegap.plugins.VolumeControl": "1.0.0",
  "org.apache.cordova.globalization": "0.2.5",
  "cordova-plugin-network-information": "1.0.1",
  "com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice.sample": "2.0.0",
  "com.rhythmicworks.red_folder.phonegap.plugin.backgroundservice": "2.0.0",
  "nl.x-services.plugins.insomnia": "4.0.1",
  "com.rhythmicworks.phonegap.plugin.analytics": "1.0",
  "cordova-plugin-inappbrowser": "1.0.1",
//   Add splash screen and whitelist as a plugin in Cordova 4.x.x+
  "org.apache.cordova.splashscreen": "2.1.0",
  "cordova-plugin-whitelist": "1.0.0",
//  AdMob for Free
 "cordova-admob": "4.1.6",
 "cordova-connectivity-monitor": "1.2.2",
}
// BOTTOM OF METADATA
});
