//keypadInput --> made true on focus and false onblur of input numbers
//Fix for jQuerymobile slider on("change",function(){...});...Issue: This event triggers on programmatically changing slider value.
window.keypadInput = false;

//Fix for iOS hide highlighted keyboard issues
// function isTextInput(node) {
    // return ['INPUT', 'TEXTAREA'].indexOf(node.nodeName) !== -1;
// }
// 
// document.addEventListener('touchstart', function(e) {
    // if (!isTextInput(e.target) && isTextInput(document.activeElement)) {
        // document.activeElement.blur();
        // log("Blurred!");
    // }
// }, false);
//-----------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------

$('#mainPage').on('pagebeforeshow', function() {
    log("mainPage: pagebeforeshow");

    // Enable the menu on coming back to main page
    if (devicereadyStatus) {
        window.setMenuView("1", function(rval) {
            if (rval != 1) {
                toast(error, "short");
            } else {
            }
            ;
        });
    }

    if(devicereadyStatus && !LITE){
          window.enableOrientationChange(false);
    }
    
    //Set buyProUpperButton height to 8vh (vh is not supported in earlier versions of Android)
    var ht = .08 * wHeight + "px"; 
    $(".buyProUpperButton").css("height",ht);
    $(".buyProUpperButton").css("line-height",ht);   
});

$("#mainPage").focusin(function() {
    if (loggingON)
        console.log('Main page focus in...');
    // in case of restarting app
    if (devicereadyStatus) {
        // if returning from TTS settings
        if (window.prefOn) {
            if (window.ttsOpened) {
                if (loggingON)
                    console.log('Back from TTS screen settings');
                window.ttsOpened = false;
                window.plugins.tts.startup(startupWin, failStartup);
            }
        }
    }
});

$('#mainPage').on('pagehide', function() {
    if (devicereadyStatus)
        window.setMenuView("0", function(rval) {
            if (rval != 0) {
                toast(error, "short")
            } else {
            }
            ;
        });

    window.mainPageON = false;
});

window.mainPageON = false;
$('#mainPage').on('pageshow', function() {
    log("mainPage: pageshow");
    window.mainPageON = true;
    
    log("Setting height of mainPage to wHeight...(Fix for keyboard resize issue)");
    document.getElementById('mainPage').style.height = window.wHeight * 1 + "px";
});

window.localStorageSupported = false;
$('#mainPage').on('pageinit', function() {
    
    //Fix for ghost click on slider issues when input keyboard is hidden
    $('#v0').slider('disable');
    $('#v1').slider('disable');
    $('#v2').slider('disable');
    $('#v3').slider('disable');
    $('#v4').slider('disable');
    
    
    var TAG = mainPageTAG + "-pageinit: ";
    log(mainPageTAG + "-pageinit");

    // Set the bottom bar height based on wHeight
    if (loggingON)
        console.log(wHeight);
    // window.bbHighlightHeight = wHeight <= 700 ? "62px" : "82px";
    // window.bbNormalHeight = wHeight <= 700 ? "15%" : "15%";

    if (window.localStorage == null) {
        log(TAG + 'localStorage not supported');
        $.when(deviceReadyDeferred).done(onGotSavedValues);
    } else {
        window.localStorageSupported = true;
        log(TAG + 'localStorage supported');
        // Get saved values
        getSavedValues();
        onGotSavedValues();
    }

    // Bind event to slidestop
    $("#beepVolSlider").on("slidestop", onBeepVolSliderStop);

    $("#v0").slider({
        start : function(event, ui) {
            log("Started!");
        },

        stop : function(event, ui) {
            log("SLide stopped!");
            manualSliderInput = false;
        }
    });

    $("#v0").on('change', function(e) {
        //Check if change was triggered programatically
        if (window.keypadInput) {
            //do nothing
            log("keypadInput..so return...");
            return;
        }

        var v = $("#v0").val();
        log("Value changed: " + v);
        if (v != '') {
            workValId.innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v.toString().toHHMMSS();
            window.workTime = v;
            window.workTimeVar = v;
            $('#n0').val(window.workTime);
        }
    });

    $("#v1").on('change input', function() {
        //Check if change was triggered programatically
        if (window.keypadInput) {
            //do nothing
            log("keypadInput..so return...");
            return;
        }
        var v = $("#v1").val();
        if (v != '') {
            countValId.innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v;
            window.countValue = v;
            window.countValueVar = v;
            $('#n1').val(window.countValue);
        }
    });

    $("#v2").on('change input', function() {
        //Check if change was triggered programatically
        if (window.keypadInput) {
            //do nothing
            log("keypadInput..so return...");
            return;
        }
        var v = $("#v2").val();
        if (v != '') {
            intSecInputId.innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v.toString().toHHMMSS();
            window.intervalTime = v;
            window.intervalTimeVar = v;
            $('#n2').val(window.intervalTime);
        }
    });

    $("#v3").on('change input', function() {
        //Check if change was triggered programatically
        if (window.keypadInput) {
            //do nothing
            log("keypadInput..so return...");
            return;
        }
        var v = $("#v3").val();
        if (v != '') {
            roundValId.innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v + "x";
            counterMode == 1 ? window.noOfRounds = v : window.noOfRoundsTimer = v;
            window.noOfRoundsVar = v;
            $('#n3').val(v);
        }
    });

    $("#v4").on('change input', function() {
        //Check if change was triggered programatically
        if (window.keypadInput) {
            //do nothing
            log("keypadInput..so return...");
            return;
        }
        var v = $("#v4").val();
        if (v != '') {
            restValId.innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v.toString().toHHMMSS();
            counterMode == 1 ? window.restTime = v : window.restTimeTimer = v;
            window.restTimeVar = v;
            $('#n4').val(v);
        }
    });
    
    
//    Set slider width to 90% of viewport width
    $(".ui-slider").width(wWidth*.90);
    
//     Initialise fast click
                  $(function() {
                        FastClick.attach(document.body);
                        });


//    Preferred Activities tap handler
    $('#gFitPreferredActivityDiv').on('tap', function(){
        showPreferredActivityTypes();

         if (gaPlugin != null){
            gaPlugin.trackEvent('Preferences', 'Preferred Activity Types click');
         }
    });
    
    
 //Disable Divs for amazon app
 if(AMZN_APP){
     log("mainPage - init: " + "Amazon app..");
     //Disable Google Fit and Android Wear
     $("#connectedServicesLabel").css("display","none");
     $("#googleFitDiv").css("display","none");
     $("#androidWearDiv").css("display","none");
     
     //App Invite won't work '
     $("#appInviteLi").css("display","none");
     $("#appInviteLi").css("display","none");
     $("#shareId").css("display","none");
     
      $("#personalDetailsInfo").css("display","none");
 }
});
//TODO: Initialise minified fast click


// -----------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------

counterDiv0 = document.getElementById('counterDiv0');
counterDiv1 = document.getElementById('counterDiv1');
counterDiv2 = document.getElementById('counterDiv2');
counterDiv3 = document.getElementById('counterDiv3');
counterDiv4 = document.getElementById('counterDiv4');

wrapper0 = document.getElementById('wrapper0');
wrapper1 = document.getElementById('wrapper1');
wrapper2 = document.getElementById('wrapper2');
wrapper3 = document.getElementById('wrapper3');
wrapper4 = document.getElementById('wrapper4');

// Set colors
document.getElementById('counterDiv0').style.color = workColor;
var el = document.getElementById('wrapper0');
el.style.backgroundColor = workColor;
// rgba(255,165,33,.4)"
el.alpha(40);
document.getElementById('ib0').style.backgroundColor = workColor;

document.getElementById('counterDiv1').style.color = workColor;
el = document.getElementById('wrapper1');
el.style.backgroundColor = workColor;
el.alpha(40);
document.getElementById('ib1').style.backgroundColor = workColor;

document.getElementById('counterDiv2').style.color = intervalColor;
el = document.getElementById('wrapper2');
el.style.backgroundColor = intervalColor;
el.alpha(40);
document.getElementById('ib2').style.backgroundColor = intervalColor;

document.getElementById('counterDiv3').style.color = roundColor;
el = document.getElementById('wrapper3');
el.style.backgroundColor = roundColor;
el.alpha(20);
document.getElementById('ib3').style.backgroundColor = roundColor;

document.getElementById('counterDiv4').style.color = restColor;
el = document.getElementById('wrapper4');
el.style.backgroundColor = restColor;
el.alpha(30);
document.getElementById('ib4').style.backgroundColor = restColor;

var labelPaddingTop = 0 + "px";

function calculateFontSizes() {
    
    document.getElementById('workVal').style.fontSize = window.wHeight / 10 + "px";
    document.getElementById('wlabel').style.fontSize = window.wHeight / 22 + "px";
    document.getElementById('wlabel').style.paddingTop = labelPaddingTop;

    document.getElementById('countVal').style.fontSize = window.wHeight / 10 + "px";
    document.getElementById('clabel').style.fontSize = window.wHeight / 22 + "px";
    document.getElementById('clabel').style.paddingTop = labelPaddingTop;

    document.getElementById('intSecInput').style.fontSize = window.wHeight / 10 + "px";
    document.getElementById('ilabel').style.fontSize = window.wHeight / 22 + "px";
    document.getElementById('ilabel').style.paddingTop = labelPaddingTop;

    document.getElementById('roundVal').style.fontSize = window.wHeight / 10 + "px";
    document.getElementById('rlabel').style.fontSize = window.wHeight / 22 + "px";
    document.getElementById('rlabel').style.paddingTop = labelPaddingTop;

    document.getElementById('restVal').style.fontSize = window.wHeight / 10 + "px";
    document.getElementById('restlabel').style.fontSize = window.wHeight / 22 + "px";
    document.getElementById('restlabel').style.paddingTop = labelPaddingTop;

    document.getElementById('h21').style.height = window.firstHt * .08 + "px";
}
calculateFontSizes();

//Set the height of mainPage - Fix for resize issue on page resize
// setTimeout(function(){alert();  
    // document.getElementById('mainPage').style.height = window.wHeight * 1 + "px";
// },3000);




$("#counterB").on('tap', function(e) {
    e.preventDefault();
    //disable the edit mode
        if (editMode) {
            editMode = false;
            log('Edit Mode disabled!');
             //Change label icon to save icon
            $("#saveButton").css("background-image","url(icons/label.png)");
        }
    setCurrentActivityType(getCurrentActivityType());
    setMode(1);
});

$("#timerB").on('tap', function(e) {
    e.preventDefault();

     //disable the edit mode
     if (editMode) {
            editMode = false;
            log('Edit Mode disabled!');
             //Change label icon to save icon
             $("#saveButton").css("background-image","url(icons/label.png)");
     }
    setCurrentActivityType(getCurrentActivityType());
    setMode(0);
});

$("#presetsB").on('tap', function(e) {
    e.preventDefault();
    showPresets();

    //disable the edit mode
    if (editMode) {
        editMode = false;
        log('Edit Mode disabled!');
        //Change label icon to save icon
        $("#saveButton").css("background-image","url(icons/label.png)");
    }
});

window.prefOn = false;
window.helpPageOn = false;

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------

function onGotSavedValues() {
    var TAG = arguments.callee.name + "(): ";

    log(TAG + "in onGotSavedValues()");
    // Set the theme based on bgImgId
    setTheme(window.bgImageId, false);
    // set mode
    if (showPresetsView) {
     // log(TAG + "* Also show presets in setStrings (since presets depends on localized string) *");
        showPresets();
    } else {
        log(TAG + "* Also call setIncludeRest in setStrings (since timer mode with rest depends on localized string) *");
        log(TAG + "Set mode: " + counterMode);
        setMode(counterMode);
    }
    window.jqmReadyDeferred.resolve();
}

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
function hidePrefs() {

    // Setting icon transfor
    // $('#quickPrefsDiv').css("-webkit-transform","rotate(-90deg)");
    $('#settingsImg').css("-webkit-transition-duration", ".25s");
    $('#settingsImg').removeClass('rotateImg');

    setTimeout(function() {
        $('#settingsImg').css("-webkit-transition-duration", "0");
    }, 25);

    $('#quickPrefsDiv').css("-webkit-transition-duration", ".25s");
    document.getElementById('quickPrefsDiv').style.webkitTransform = "rotateY(90deg)";
    prefOn = false;
    // Hide the div from DOM:the prefDiv1
    document.getElementById('prefDiv1').style.display = "none";
    document.getElementById('prefLabel').style.visibility = "hidden";

    // set the preferences i.e. sounds
    setPreferences();
    // Save the values
    saveValues();
    // Enable menu
    if (devicereadyStatus)
        window.setMenuView("1", function(rval) {
            if (rval != 0) {
                // toast(error, "short")
            } else {

            }
        });

    // Set the correct screenName
    if (gaPlugin != null) {
        if (showPresetsView) {
            s = 'Presets';
        } else {
            var s = '';
            if (counterMode == 1) {// counter
                s = 'Counter';
            } else {// timer
                s = 'Timer';
            }
        }
        gaPlugin.trackView(s);
    }
}

function showPref() {
    if (!prefOn) {
        // Setting icon transfor
        // $('#settingsImg').css("-webkit-transform","rotate(90deg)");
        $('#settingsImg').css("-webkit-transition-duration", ".7s");
        $('#settingsImg').addClass('rotateImg');

        $('#quickPrefsDiv').css("-webkit-transition-duration", ".40s");
        // Display:block the prefDiv1
        document.getElementById('prefDiv1').style.display = "block";

        document.getElementById('prefLabel').style.visibility = "visible";

        // Get and set previous value
        document.getElementById('sdVal').innerHTML = "<img style=\"height:100%; vertical-align:middle\" />" + startDelay.toString().toHHMMSS();

        $('#321AlertCB').prop('checked', window.beep321Status == 1);
        $('#nextRoundCB').prop('checked', window.nextRoundAlert == 1);
        $('#vibrationCB').prop('checked', window.vibrateStatus == 1);

        $('#soundCB').prop('checked', window.soundStatus == 1);
        // Audio focus
        $('#audioFocusCB').prop('checked', window.enableAF);

        $('#halfwayTimerAlertCB').prop('checked', window.halfwayTimerAlert == 1);
        if (window.halfwayTimerAlert == 1) {
            $('#tHalfwayLI').css("display", "block");
        } else {
            $('#tHalfwayLI').css("display", "none");
        }
        
        
        if (window.soundStatus == 1) {
            // setSoundOnState
            $('#soundSettingsDiv').css("opacity", "1");
        } else {
            // setSoundOffState
            $('#soundSettingsDiv').css("opacity", ".35");
        }
        
        // if (window.soundStatus == 1) {
            // // setSoundOnState
            // $('#321AlertCB').prop("disabled", false);
            // $('#321AlertDiv').css("opacity", "1");
            // $('#nextRoundCB').prop("disabled", false);
            // $('#nextRoundDiv').css("opacity", "1");
            // $('#audioFocusCB').prop("disabled", false);
            // $('#audioFocusDiv').css("opacity", "1");
            // $('#beepVolSlider').slider('enable');
            // $('#beepVolDiv').css("opacity", "1");
        // } else {
            // // setSoundOffState
            // $('#321AlertCB').prop("disabled", true);
            // $('#321AlertDiv').css("opacity", ".35");
            // $('#nextRoundCB').prop("disabled", true);
            // $('#nextRoundDiv').css("opacity", ".35");
            // $('#audioFocusCB').prop("disabled", true);
            // $('#audioFocusDiv').css("opacity", ".35");
            // $('#beepVolSlider').slider('disable');
            // $('#beepVolDiv').css("opacity", ".35");
        // }

        // Set the counter type/count
        if (!window.autoCount)
            window.descCount == true ? $('#countDown').prop('checked', true) : $('#countUp').prop('checked', true);
        else
            $('#autoCount').prop('checked', true);

        window.preCount == true ? $('#preCount').prop('checked', true) : $('#postCount').prop('checked', true);

        // window.counterAlerts=='voice' ? $('#voiceCA').prop('checked', true) :
        // $('#beepsCA').prop('checked', true);

        // Timer
        // window.timerAlerts=='voice' ? $('#voiceTA').prop('checked', true) :
        // $('#beepsTA').prop('checked', true);

        // Set the beeps
        $('#startBeep').html(startBeepName[startBeepId]);
        $('#restBeep').html(restBeepName[restBeepId]);
        $('#a321Beep').html(a321BeepName[a321BeepId]);
        $('#startTimerBeep').html(startBeepName[startTimerBeepId]);
        $('#halfwayTimerBeep').html(halfwayBeepName[halfwayTimerBeepId]);
        $('#restTimerBeep').html(restBeepName[restTimerBeepId]);
        $('#a321TimerBeep').html(a321BeepName[a321TimerBeepId]);
        // $('#countBeep').html(countBeep[countBeepId]);

        // End beep
        $('#endBeep').html(endBeepName[endBeepId]);

        // Set app volume
        // $('#beepVolSlider').val(beepAppVolume);
        // $('#beepVolSlider').slider("refresh");
        // setVolImage(window.beepAppVolume,1);

        // Other prefs
        $('#lastRestIntervalCB').prop('checked', window.enableLastRest);
        $('#gaCB').prop('checked', window.enableGA);

        // Show prefDiv
        document.getElementById('quickPrefsDiv').style.webkitTransform = "rotateY(0deg)";
        // Hide the menu
        if (devicereadyStatus)
            window.setMenuView("0", function(rval) {
                if (rval != 0) {
                    toast(error, "short");
                } else {
                }
                ;
            });
        prefOn = true;
        // Add eventlistener for backbutton press
        // document.addEventListener("backbutton", onBackKeyDown, false);

        // for GA
        if (gaPlugin != null)
            gaPlugin.trackView('Preferences-1');

        //Active Calories Status
        setActiveCaloriesStatusInPrefs();


    } else {
        hidePrefs();

    }
}

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// De-coupling tap and tap hold
window.tapHold = false;

// Callback function references the event target and adds the 'tap' class to it
function tapholdHandler(event) {
    if (!tapHold) {
        event.stopImmediatePropagation();
        event.preventDefault();
        showPref();
    } else
        tapHold = false;
    // done with taphold
}

// Bind the tapholdHandler callback function to the taphold event on div.box
$("#prefs").on('tap', tapholdHandler);

window.bgImageId = 1;
var bgImg;

$("#prefs").on('taphold', function(event) {
    if (LITE) {
        return;
    }

    event.stopImmediatePropagation();

    // taphold fired
    window.tapHold = true;

    bgImageId++;
    if (bgImageId > totalBgImages)
        bgImageId = 1;

    setTheme(bgImageId, false);
    if (devicereadyStatus)
        vibrate(tvHapticFeedBack);

    // for GA
    var label = 'b' + bgImageId + '.jpg';
    if (gaPlugin != null)
        gaPlugin.trackEvent('Theme', 'change background', label);

});

$("#startLabel").on('tap', function() {
    onStart();
});

$("#tTime").on("tap", function() {
    onStart();
});

window.pressedWhite = "#777";
// var normalWhite= "#fff";

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// Handling the keyboard shown event
window.firstHt = window.wHeight;
$(window).resize(function() {
    newHt = window.innerHeight;
    if (newHt < firstHt) {
        // Disable the innerbottoms
        $('#slider0').off('touchstart ', ib0TouchStart);
        $('#slider1').off('touchstart ', ib1TouchStart);
        $('#slider2').off('touchstart ', ib2TouchStart);
        $('#slider3').off('touchstart ', ib3TouchStart);
        $('#slider4').off('touchstart ', ib4TouchStart);

        $('#slider0').off('touchend ', ib0TouchEnd);
        $('#slider1').off('touchend ', ib1TouchEnd);
        $('#slider2').off('touchend ', ib2TouchEnd);
        $('#slider3').off('touchend ', ib3TouchEnd);
        $('#slider4').off('touchend ', ib4TouchEnd);
    } else {
        // document.getElementById('d1').style.overflow="hidden";
        $('#mainPage').focus();
        $('#slider0').on('touchstart ', ib0TouchStart);
        $('#slider1').on('touchstart ', ib1TouchStart);
        $('#slider2').on('touchstart ', ib2TouchStart);
        $('#slider3').on('touchstart ', ib3TouchStart);
        $('#slider4').on('touchstart ', ib4TouchStart);

        $('#slider0').on('touchend ', ib0TouchEnd);
        $('#slider1').on('touchend ', ib1TouchEnd);
        $('#slider2').on('touchend ', ib2TouchEnd);
        $('#slider3').on('touchend ', ib3TouchEnd);
        $('#slider4').on('touchend ', ib4TouchEnd);
    }
});

// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------

workValId = document.getElementById('workVal');
countValId = document.getElementById('countVal');
intSecInputId = document.getElementById('intSecInput');
roundValId = document.getElementById('roundVal');
restValId = document.getElementById('restVal');
v0 = document.getElementById('v0');
v1 = document.getElementById('v1');
v2 = document.getElementById('v2');
v3 = document.getElementById('v3');
v4 = document.getElementById('v4');


// -----------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// ---------------------------------------------------------------------------------------------------------------------------------
// ---------------------------------------------------------------------------------------------------------------------------------
// Work
function ib0TouchStart() {
    //Fix for ghost click issue
    $('#v0').slider('enable');
    
    // console.log("ib0TouchStart - 1");
    highlight('wrapper0', 'ib0');
    $("#ib0").addClass('z');
    // Make bgDiv visible
    document.getElementById('bgDiv').style.visibility = "visible";
    // $('#bgDivTop').css({
        // visibility : "visible",
        // backgroundColor : workColor
    // });

    counterDiv0.style.visibility = "hidden";
    wrapper0.style.visibility = "hidden";
    // Bring to forth
    // $('#counterDiv0').css({zIndex:5, top:"-10%"});
    // $('#wrapper0').css({zIndex:5, top:"-10%",left:"0",right:"0"});
    counterDiv0.style.zIndex = "6";
    counterDiv0.style.top = "-10%";
    wrapper0.style.zIndex = "5";
    wrapper0.style.top = "-10%";
    wrapper0.style.left = "0";
    wrapper0.style.right = "0";
    counterDiv0.style.visibility = "visible";
    wrapper0.style.visibility = "visible";

    document.getElementById('n0').style.zIndex = 5;

    document.getElementById('bgDivBottom').style.top = 0;//$('#wrapper0').height() + "px";
    // Take number inputs to back
    sendBackNoInputs();
    // console.log("ib0TouchStart - 2");
}

function ib0TouchEnd() {
    // console.log("ib0TouchEnd - 1");
    $("#ib0").removeClass('z');
    document.getElementById('n0').style.zIndex = 3;

    counterDiv0.style.visibility = "hidden";
    wrapper0.style.visibility = "hidden";
    // $('#counterDiv0').css({zIndex:3, top:"2%"});
    counterDiv0.style.zIndex = "3";
    counterDiv0.style.top = "2%";
    wrapper0.style.zIndex = "2";
    wrapper0.style.top = "2%";
    wrapper0.style.left = "10px";
    wrapper0.style.right = "10px";
    // $('#wrapper0').css({zIndex:2, top:"2%",left:"10px",right:"10px"});
    counterDiv0.style.visibility = "visible";
    wrapper0.style.visibility = "visible";

    // Bring front no inputs
    bringFrontNumberInputs();
    // Make bgDiv hidden
    document.getElementById('bgDiv').style.visibility = "hidden";
    // $('#bgDivTop').css({
        // visibility : "hidden",
        // backgroundColor : "#101010"
    // });
    dehighlight('wrapper0', 'ib0');
    // console.log("ib0TouchEnd - 2");
    
     //Fix for ghost click issue
    $('#v0').slider('disable');
}


$('#slider0').on('touchstart ', ib0TouchStart);
$('#slider0').on('touchend ', ib0TouchEnd);

// Counts
function ib1TouchStart() {
     //Fix for ghost click issue
    $('#v1').slider('enable');
    
    
    highlight('wrapper1', 'ib1');
    $("#ib1").addClass('z');

    document.getElementById('bgDiv').style.visibility = "visible";
    // $('#bgDivTop').css({
        // visibility : "visible",
        // backgroundColor : workColor
    // });
    document.getElementById('n1').style.zIndex = 5;

    counterDiv1.style.visibility = "hidden";
    wrapper1.style.visibility = "hidden";
    $('#counterDiv1').css({
        zIndex : 6,
        top : "-10%"
    });
    $('#wrapper1').css({
        zIndex : 5,
        top : "-10%",
        left : "0",
        right : "0"
    });
    counterDiv1.style.visibility = "visible";
    wrapper1.style.visibility = "visible";

    // Take number inputs to back
    sendBackNoInputs();

    document.getElementById('bgDivBottom').style.top = 0;//$('#wrapper1').height() + "px";

}

function ib1TouchEnd() {
    $("#ib1").removeClass('z');

    // Bring front no inputs
    bringFrontNumberInputs();
    document.getElementById('n1').style.zIndex = 3;

    counterDiv1.style.visibility = "hidden";
    wrapper1.style.visibility = "hidden";
    $('#counterDiv1').css({
        zIndex : 3,
        top : "2%"
    });
    $('#wrapper1').css({
        zIndex : 2,
        top : "2%",
        left : "10px",
        right : "10px"
    });
    counterDiv1.style.visibility = "visible";
    wrapper1.style.visibility = "visible";

    document.getElementById('bgDiv').style.visibility = "hidden";
    // $('#bgDivTop').css({
        // visibility : "hidden",
        // backgroundColor : "#101010"
    // });
    dehighlight('wrapper1', 'ib1');
    
     //Fix for ghost click issue
    $('#v1').slider('disable');

}


$('#slider1').on('touchstart ', ib1TouchStart);
$('#slider1').on('touchend ', ib1TouchEnd);

// Interval
function ib2TouchStart() {
     //Fix for ghost click issue
    $('#v2').slider('enable');
    
    highlight('wrapper2', 'ib2');
    $("#ib2").addClass('z');
    // Make bgDiv visible
    document.getElementById('bgDiv').style.visibility = "visible";
    //document.getElementById('bgDivTop').style.visibility = "visible";
    //document.getElementById('bgDivTop').style.backgroundColor = intervalColor;
    document.getElementById('n2').style.zIndex = 5;

    // Take number inputs to back
    sendBackNoInputs();

    counterDiv2.style.visibility = "hidden";
    wrapper2.style.visibility = "hidden";
    $('#counterDiv2').css({
        zIndex : 6,
        top : "8%"
    });
    $('#wrapper2').css({
        zIndex : 5,
        top : "8%",
        left : "0",
        right : "0"
    });
    counterDiv2.style.visibility = "visible";
    wrapper2.style.visibility = "visible";

    document.getElementById('bgDivBottom').style.top = 0;//$('#wrapper2').height() + "px";
}

function ib2TouchEnd() {
    $("#ib2").removeClass('z');
    document.getElementById('n2').style.zIndex = 3;

    counterDiv2.style.visibility = "hidden";
    wrapper2.style.visibility = "hidden";
    // Change dimensions
    $('#counterDiv2').css({
        zIndex : 3,
        top : "20%"
    });
    $('#wrapper2').css({
        zIndex : 2,
        top : "20%",
        left : "10px",
        right : "10px"
    });
    counterDiv2.style.visibility = "visible";
    wrapper2.style.visibility = "visible";

    // Bring front no inputs
    bringFrontNumberInputs();

    // Make bgDiv hidden
    document.getElementById('bgDiv').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.backgroundColor = "#101010";
    dehighlight('wrapper2', 'ib2');
    
     //Fix for ghost click issue
    $('#v2').slider('disable');
}


$('#slider2').on('touchstart ', ib2TouchStart);
$('#slider2').on('touchend ', ib2TouchEnd);

// Rounds
function ib3TouchStart() {
    //Fix for ghost click issue
    $('#v3').slider('enable');
    
    highlight('wrapper3', 'ib3');
    $("#ib3").addClass('z');
    // Make bgDiv visible
    document.getElementById('bgDiv').style.visibility = "visible";
    // document.getElementById('bgDivTop').style.visibility = "visible";
    // document.getElementById('bgDivTop').style.backgroundColor = roundColor;

    document.getElementById('n3').style.zIndex = 5;

    counterDiv3.style.visibility = "hidden";
    wrapper3.style.visibility = "hidden";
    // Change dimensions
       // Change dimensions
    if(counterMode == 1){
        $('#counterDiv3').css({
                              zIndex : 6,
                              top : "44%"
                              });
        $('#wrapper3').css({
                           zIndex : 5,
                           top : "44%",
                           left : "0",
                           right : "0"
                           });
        document.getElementById('bgDivBottom').style.top = 0;//"74%";//$('#wrapper3').height() + "px";
    }else{
        $('#counterDiv3').css({
                              zIndex : 6,
                              top : "26%"
                              });
        $('#wrapper3').css({
                           zIndex : 5,
                           top : "26%",
                           left : "0",
                           right : "0"
                           });
        document.getElementById('bgDivBottom').style.top = 0;//"58%";//$('#wrapper3').height() + "px";
    }
 
    counterDiv3.style.visibility = "visible";
    wrapper3.style.visibility = "visible";

    // Take number inputs to back
    sendBackNoInputs();

}

function ib3TouchEnd() {
    $("#ib3").removeClass('z');
    // $("#ib3").removeClass('roundColorGradient');
    // Move to back
    document.getElementById('counterDiv3').style.zIndex = 3;
    document.getElementById('n3').style.zIndex = 3;

    counterDiv3.style.visibility = "hidden";
    wrapper3.style.visibility = "hidden";
    // Change dimensions
    if (counterMode) {
        document.getElementById('counterDiv3').style.top = "56%";
        document.getElementById('wrapper3').style.top = "56%";
    } else {
        document.getElementById('counterDiv3').style.top = "38%";
        document.getElementById('wrapper3').style.top = "38%";
    }

    $('#wrapper3').css({
        zIndex : 2,
        left : "10px",
        right : "10px"
    });
    counterDiv3.style.visibility = "visible";
    wrapper3.style.visibility = "visible";

    // Bring front no inputs
    bringFrontNumberInputs();

    // Make bgDiv hidden
    document.getElementById('bgDiv').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.backgroundColor = "#101010";
    dehighlight('wrapper3', 'ib3');
    
     //Fix for ghost click issue
    $('#v3').slider('disable');
}


$('#slider3').on('touchstart ', ib3TouchStart);
$('#slider3').on('touchend ', ib3TouchEnd);

// Rest
function ib4TouchStart() {
     //Fix for ghost click issue
    $('#v4').slider('enable');
    
    highlight('wrapper4', 'ib4');
    $("#ib4").addClass('z');
    // Make bgDiv visible
    document.getElementById('bgDiv').style.visibility = "visible";
    // document.getElementById('bgDivTop').style.visibility = "visible";
    //document.getElementById('bgDivTop').style.backgroundColor = restColor;

    document.getElementById('n4').style.zIndex = 5;

    counterDiv4.style.visibility = "hidden";
    wrapper4.style.visibility = "hidden";
    // Change dimensions
    if(counterMode == 1){
        $('#counterDiv4').css({
                              zIndex : 6,
                              top : "26%"
                              });
        $('#wrapper4').css({
                           zIndex : 5,
                           top : "26%",
                           left : "0",
                           right : "0"
                           });
        document.getElementById('bgDivBottom').style.top = 0;//"58%";//$('#wrapper4').height() + "px";
    }else{
        $('#counterDiv4').css({
                              zIndex : 6,
                              top : "8%"
                              });
        $('#wrapper4').css({
                           zIndex : 5,
                           top : "8%",
                           left : "0",
                           right : "0"
                           });
        document.getElementById('bgDivBottom').style.top = 0;//"42%";//$('#wrapper4').height() + "px";
    }

    counterDiv4.style.visibility = "visible";
    wrapper4.style.visibility = "visible";

    // Take number inputs to back
    sendBackNoInputs();
}

function ib4TouchEnd() {
    $("#ib4").removeClass('z');
    // Move to back
    document.getElementById('counterDiv4').style.zIndex = 3;
    document.getElementById('n4').style.zIndex = 3;

    counterDiv4.style.visibility = "hidden";
    wrapper4.style.visibility = "hidden";
    // Change dimensions
    if (counterMode) {
        document.getElementById('counterDiv4').style.top = "38%";
        document.getElementById('wrapper4').style.top = "38%";
    } else {
        document.getElementById('counterDiv4').style.top = "20%";
        document.getElementById('wrapper4').style.top = "20%";
    }

    $('#wrapper4').css({
        zIndex : 2,
        left : "10px",
        right : "10px"
    });
    counterDiv4.style.visibility = "visible";
    wrapper4.style.visibility = "visible";

    // Bring front no inputs
    bringFrontNumberInputs();

    // Make bgDiv hidden
    document.getElementById('bgDiv').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.visibility = "hidden";
    // document.getElementById('bgDivTop').style.backgroundColor = "#101010";
    dehighlight('wrapper4', 'ib4');
    
     //Fix for ghost click issue
    $('#v4').slider('disable');
}


$('#slider4').on('touchstart ', ib4TouchStart);
$('#slider4').on('touchend ', ib4TouchEnd);
// -------------------------------------------------------------------
function toTimeFormat(v) {

    var mins = Math.floor(v / 100);
    var secs = v % 100;
    if (secs < 10)
        return (mins + ":0" + secs);
    else
        return (mins + ":" + secs);
}

// -------------------------------------------------------------------
// -------------------------------------------------------------------
$('#n0').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n0").val());
    $("#n0").val(v);
    if (v >= 1 && v <= 5959) {
        // Convert to seconds
        var s = v % 100 + (Math.floor(v / 100) * 60);
        document.getElementById('workVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + toTimeFormat(v);
        window.workTimeVar = s;
        $("#v0").val(s).slider('refresh');
    } else {
        document.getElementById('workVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + "0:00";
        window.workTimeVar = 0;
        $("#n0").val(null);
    }
    calTotalTimeDontSaveValues();
});

$('#n1').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n1").val());
    $("#n1").val(v);
    // console.log(v);
    if (v >= 1 && v < 10000) {
        document.getElementById('countVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v;
        window.countValueVar = v;
        $("#v1").val(v).slider('refresh');
    } else {
        document.getElementById('countVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + "0";
        window.countValueVar = 0;
        $("#n1").val(null);
    }
    calTotalTimeDontSaveValues();
});

$('#n2').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n2").val());
    $("#n2").val(v);
    if (v >= 1 && v <= 5959) {
        // Convert to seconds
        var s = v % 100 + (Math.floor(v / 100) * 60);
        document.getElementById('intSecInput').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + toTimeFormat(v);
        window.intervalTimeVar = s;
        $("#v2").val(s).slider('refresh');
    } else {
        document.getElementById('intSecInput').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + "0:00";
        window.intervalTimeVar = 0;
        $("#n2").val(null);
    }
    calTotalTimeDontSaveValues();
});

$('#n3').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n3").val());
    $("#n3").val(v);
    if (v >= 1 && v < 10000) {
        document.getElementById('roundVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + v + "x";
        window.noOfRoundsVar = v;
        $("#v3").val(v).slider('refresh');
    } else {
        document.getElementById('roundVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + "0" + "x";
        window.noOfRoundsVar = 0;
        $("#n3").val(null);
    }
    calTotalTimeDontSaveValues();
});

$('#n4').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n4").val());
    $("#n4").val(v);
    if (v >= 1 && v <= 5959) {
        // Convert to seconds
        var s = v % 100 + (Math.floor(v / 100) * 60);
        document.getElementById('restVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + toTimeFormat(v);
        window.restTimeVar = s;
        $("#v4").val(s).slider('refresh');
    } else {
        document.getElementById('restVal').innerHTML = "<img style=\"height:100%; vertical-align:baseline\" />" + "0:00";
        window.restTimeVar = 0;
        $("#n4").val(null);
    }
    calTotalTimeDontSaveValues();
});

// Preferences div(main page) bindings

$('#n5').on("propertychange keyup input paste", function(event) {
    var v = Math.floor($("#n5").val());
    $("#n5").val(v);
    if (v >= 1 && v <= 5959) {
        // Convert to seconds
        var s = v % 100 + (Math.floor(v / 100) * 60);
        document.getElementById('sdVal').innerHTML = "<img style=\"height:100%; vertical-align:middle\" />" + toTimeFormat(v);
        window.startDelayVar = s;
    } else {
        document.getElementById('sdVal').innerHTML = "<img style=\"height:100%; vertical-align:middle\" />" + "0:00";
        window.startDelayVar = 0;
        $("#n5").val(null);
    }
    // calTotalTimeDontSaveValues();
});

// Binding the checkboxes
$('#321AlertCB').on('change', function() {

    if ($('#321AlertCB').is(':checked')) {
        // the checkbox was checked
        window.beep321Status = 1;
    } else {
        // the checkbox was unchecked
        window.beep321Status = 0;
    }

});

$('#nextRoundCB').on('change', function() {

    if ($('#nextRoundCB').is(':checked')) {
        // the checkbox was checked
        window.nextRoundAlert = 1;
    } else {
        // the checkbox was unchecked
        window.nextRoundAlert = 0;
    }

});

$('#halfwayTimerAlertCB').on('change', function() {

    if ($('#halfwayTimerAlertCB').is(':checked')) {
        // the checkbox was checked
        window.halfwayTimerAlert = 1;
        $('#tHalfwayLI').css("display", "block");
        // $('#tHalfwayLI').css("opacity","1");
    } else {
        // the checkbox was unchecked
        window.halfwayTimerAlert = 0;
        $('#tHalfwayLI').css("display", "none");
        // $('#tHalfwayLI').css("opacity",".35");
    }

});

$('#vibrationCB').on('change', function() {

    if ($('#vibrationCB').is(':checked')) {
        // the checkbox was checked
        window.vibrateStatus = 1;
    } else {
        // the checkbox was unchecked
        window.vibrateStatus = 0;
    }

});

$('#soundCB').on('change', function() {
    if ($('#soundCB').is(':checked')) {
        // the checkbox was checked
        window.soundStatus = 1;
        $('#soundSettingsDiv').css("opacity", "1");
        // $('#321AlertCB').prop("disabled", false);
        // $('#321AlertDiv').css("opacity", "1");
        // $('#nextRoundCB').prop("disabled", false);
        // $('#nextRoundDiv').css("opacity", "1");
        // $('#audioFocusCB').prop("disabled", false);
        // $('#audioFocusDiv').css("opacity", "1");
        // $('#beepVolSlider').slider('enable');
        // $('#beepVolDiv').css("opacity", "1");
        // Check for low device volume
        if (devicereadyStatus) {
            deviceVolume = -1;
            VolumeControl.getVolume(getVolSuccess, getVolError);
        } else if (loggingON)
            console.log('check for low device volume');
    } else {
        // the checkbox was unchecked
        window.soundStatus = 0;
         $('#soundSettingsDiv').css("opacity", ".35");
        // $('#321AlertCB').prop("disabled", true);
        // $('#321AlertDiv').css("opacity", ".35");
        // $('#nextRoundCB').prop("disabled", true);
        // $('#nextRoundDiv').css("opacity", ".35");
        // $('#audioFocusCB').prop("disabled", true);
        // $('#audioFocusDiv').css("opacity", ".35");
        // $('#beepVolSlider').slider('disable');
        // $('#beepVolDiv').css("opacity", ".35");
    }

});

/*
 * $('#timerAlertsCB').on('change',function(){
 *
 * if ($('#timerAlertsCB').is(':checked')) { // the checkbox was checked
 * window.timerAlerts = "voice"; } else { // the checkbox was unchecked
 * window.timerAlerts = "beeps"; }
 *
 * });
 *
 * $('#counterAlertsCB').on('change',function(){
 *
 * if ($('#counterAlertsCB').is(':checked')) { // the checkbox was checked
 * window.counterAlerts = "voice"; } else { // the checkbox was unchecked
 * window.counterAlerts = "beeps"; }
 *
 * });
 */

$('#defaultCounterSettings2').on('tap', function() {
    setDefaultCounterSettings();
});

$('#defaultCounterSettings1').on('tap', function() {
    setDefaultCounterModeSettings();
});


$('#defaultTimerSettings').on('tap', function() {
    setDefaultTimerSettings();
});

$('#defaultOtherSettings').on('tap', function() {
    setDefaultOtherSettings();
});

$('.defaultB').on('touchstart', function(e) {
    e.target.style.backgroundSize = "15px 15px";
});
$('.defaultB').on('touchend touchcancel touchmove', function(e) {
    e.target.style.backgroundSize = "20px 20px";
});

$('.info').on('touchstart', function(e) {
    e.target.style.backgroundSize = "17px 17px";
});
$('.info').on('touchend touchcancel touchmove', function(e) {
    e.target.style.backgroundSize = "20px 20px";
});

$('.prevB').on('touchstart', function(e) {
    e.target.style.backgroundSize = "17px 17px";
});
$('.prevB').on('touchend touchcancel touchmove', function(e) {
    e.target.style.backgroundSize = "20px 20px";
});

$('.nextB').on('touchstart', function(e) {
    e.target.style.backgroundSize = "17px 17px";
});
$('.nextB').on('touchend touchcancel touchmove', function(e) {
    e.target.style.backgroundSize = "20px 20px";
});

$('#audioFocusCB').on('change', function() {

    if ($('#audioFocusCB').is(':checked')) {
        // the checkbox was checked
        window.enableAF = true;
    } else {
        // the checkbox was unchecked
        window.enableAF = false;
    }

});

$('#lastRestIntervalCB').on('change', function() {

    if ($('#lastRestIntervalCB').is(':checked')) {
        // the checkbox was checked
        window.enableLastRest = true;
    } else {
        // the checkbox was unchecked
        window.enableLastRest = false;
    }
    
    if (showPresetsView) {
        // recalculate the total Time
        loadPresets();
    }else{
        calTotalTimeDontSaveValues();
    }

//  --------------------------------------------------------------------------------------------------------
//    Since lastRest affect presetsView and updateNativeDb reloads presets view (indirect update)
    saveValues();
    updateNativeDB();
//    --------------------------------------------------------------------------------------------------------
});

$('#gaCB').on('change', function() {
    if ($('#gaCB').is(':checked')) {
        // the checkbox was checked
        window.enableGA = true;
        if (loggingON)
            console.log("Enabling Google Analytics..");
        if (devicereadyStatus)
            startGAPlugin();

        $.when(gaStartedDeferred).done(function() {
            if (gaPlugin != null)
                gaPlugin.trackEvent('Google Analytics', 'set ON');
        });

    } else {
        if (gaPlugin != null)
            gaPlugin.trackEvent('Google Analytics', 'set OFF');

        // the checkbox was unchecked
        window.enableGA = false;
        if (devicereadyStatus)
            exitGAPlugin();
    }

});
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------
$('#startLabel').on('touchstart', function() {
    $('#startLabel').css("color", pressedWhite);
    $('#tTime').css("color", pressedWhite);
    // $('#startCircle').css("border-color","rgb(28,28,28)");
});

$('#startLabel').on('touchend touchcancel touchmove', function() {
    $('#startLabel').css("color", "#fff");
    $('#tTime').css("color", "#fff");
});

$('#tTime').on('touchstart', function() {
    $('#startLabel').css("color", pressedWhite);
    $('#tTime').css("color", pressedWhite);
    // $('#startCircle').css("border-color","rgb(28,28,28)");

});

$('#tTime').on('touchend touchcancel touchmove', function() {
    $('#startLabel').css("color", "#fff");
    $('#tTime').css("color", "#fff");
});

window.ttsOpened = false;
$('#ttsDiv').on('tap', function() {
    if (loggingON)
        console.log("calling..shutdownTTS");
    // shutdown the tts which would be restarted later in setPreferences
    shutdownTTS();
    if (loggingON)
        console.log("calling...openTTS()");
    window.ttsOpened = true;
    // Open TTS settings
    window.openTTS();

    if (gaPlugin != null)
        gaPlugin.trackEvent('Preferences', 'TTS settings click');
});

$('#helpDiv').on('tap', function(e) {
    // var lan = getCurrentLanguage();
    // var helpPageURL = getHelpPagesPath() + "help_" + lan + ".html";
    // $.mobile.navigate(helpPageURL, {
        // transition : 'none',
        // changeHash : true
    // });
    e.preventDefault();
    goToPage("#helpPage");
});

$('#aboutDiv').on('tap', function(e) {
    e.preventDefault();
    goToPage("#aboutPage");
});


var liTouched = false;
var liTouchedTimeoutTimer;
var liTouched;
var liTouchThreshold = 5; ///in ms
$('.highlightPrefsLi').on('touchstart', function(e) {
    liTouched = $(this);
    liTouchedTimeoutTimer = setTimeout(function(){
        liTouched.addClass('highlightLi');
    },liTouchThreshold);
    
});

$('.highlightPrefsLi').on('tap', function(e) {
     liTouched = $(this);
     liTouched.addClass('highlightLi');
     setTimeout(function(){
       liTouched.removeClass('highlightLi');
    },100);
});

$('.highlightPrefsLi').on('touchend touchcancel touchmove', function(e) {
    clearTimeout(liTouchedTimeoutTimer);
    $(this).removeClass('highlightLi');
});
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------

$('#reportTranslationError').on('tap', function() {
     //open external
    var options = 'location=no,toolbarposition=top';
    var ref = window.open('https://docs.google.com/forms/d/1SllrZjbiLmyQIffQf5d6Ac-7iQlNNKtJ0Zyyj3LNDD8/viewform', '_blank', options);
    ref.addEventListener("exit", function(){
        if (gaPlugin != null)
            gaPlugin.trackView('Preferences-1');
    });
    if (gaPlugin != null)
         gaPlugin.trackView('Report translaton bug');
});

$('#toggleTranslation').on('tap', function() {
    toggleTranslation();
});

$('#volunteerToTranslate').on('tap', function() {
     //open external
    var options = 'location=no,toolbarposition=top';
    var ref = window.open('https://docs.google.com/forms/d/1NtygL5Y4gO0p1MBTrPTOIrcLyacerJ0DGzroC5VjMHk/viewform', '_blank', options);
    ref.addEventListener("exit", function(){
        if (gaPlugin != null)
            gaPlugin.trackView('Preferences-1');
    });
    if (gaPlugin != null)
         gaPlugin.trackView('Volunteer for translation');
});
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// Hide prefs on click on prefLabel
$("#prefLabel").on('tap', function(event) {
    // event.stopImmediatePropagation()
    // event.stopPropagation();
    // hidePrefs();
});

// Hide help on click on prefLabel
$("#helpLabel").on('tap', function(event) {
    event.stopPropagation();
    hideHelp();
});
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
    if (!LITE) {
        $('#prevStartB').on('tap', prevStartBeep);
        $('#prevRestB').on('tap', prevRestBeep);
        $('#prev321B').on('tap', prevA321Beep);
        $('#nextStartB').on('tap', nextStartBeep);
        $('#nextRestB').on('tap', nextRestBeep);
        $('#next321B').on('tap', nextA321Beep);

        $('#prevStartTimerB').on('tap', prevStartTimerBeep);
        $('#prevHalfwayTimerB').on('tap', prevHalfwayTimerBeep);
        $('#prevRestTimerB').on('tap', prevRestTimerBeep);
        $('#prev321TimerB').on('tap', prevA321TimerBeep);
        $('#nextStartTimerB').on('tap', nextStartTimerBeep);
        $('#nextHalfwayTimerB').on('tap', nextHalfwayTimerBeep);
        $('#nextRestTimerB').on('tap', nextRestTimerBeep);
        $('#next321TimerB').on('tap', nextA321TimerBeep);

        $('#prevEndB').on('tap', prevEndBeep);
        $('#nextEndB').on('tap', nextEndBeep);

        $('#a321TimerBeep').on('tap', function() {
            playBeep('sounds/a321/', a321Beep[a321TimerBeepId], '.ogg');
        });
        $('#startTimerBeep').on('tap', function() {
            playBeep('sounds/start/', startBeep[startTimerBeepId], '.ogg');
        });
        $('#halfwayTimerBeep').on('tap', function() {
            playBeep('sounds/start/', halfwayBeep[halfwayTimerBeepId], '.ogg');
        });
        $('#restTimerBeep').on('tap', function() {
            playBeep('sounds/start/', restBeep[restTimerBeepId], '.ogg');
        });
        $('#a321Beep').on('tap', function() {
            playBeep('sounds/a321/', a321Beep[a321BeepId], '.ogg');
        });
        $('#startBeep').on('tap', function() {
            playBeep('sounds/start/', startBeep[startBeepId], '.ogg');
        });
        $('#restBeep').on('tap', function() {
            playBeep('sounds/start/', restBeep[restBeepId], '.ogg');
        });

        $('#endBeep').on('tap', function() {
            playBeep('sounds/end/', endBeep[endBeepId], '.ogg');
        });
    }

// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// Counter settings radio button events

$("input[name='counterType']").change(function() {
    window.autoCount = false;
    if (this.value == 'countup') {
        if (loggingON)
            console.log("Count up");
        window.descCount = false;
    } else if (this.value == 'countdown') {
        if (loggingON)
            console.log("Count down");
        window.descCount = true;
    } else if (this.value == 'autoCount') {
        if (loggingON)
            console.log("Auto count");
        window.autoCount = true;
    }
});

$("input[name='pc']").change(function() {

    if (this.value == 'preCount') {
        if (loggingON)
            console.log("Count before repetition");
        window.preCount = true;

    } else if (this.value == 'postCount') {
        if (loggingON)
            console.log("Count after repetition");
        window.preCount = false;
    }
});

/*
* $("input[name='ta']").change(function(){ window.timerAlerts = this.value; });
*
* $("input[name='ca']").change(function(){ window.counterAlerts = this.value;
* });
*/
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// Save the current timer/counter
$('#saveButton').on('touchstart', function() {
    // $('#saveButton').css('background-size', 'auto 36px');
     $('#saveButton').addClass("bigBackground");
});

$('#saveButton').on('touchend touchcancel touchmove', function() {
    //$('#saveButton').css('background-size', 'auto 30px');
    $('#saveButton').removeClass("bigBackground");
});

$('#saveButton').on('tap', function() {

    if (testingMode == 'chrome') {
        alert("Calling on Prompt with 'Pull-ups'");
        onSaveButtonClick('Preset', 'Not known(TODO)');
    } else {
        showSavePrompt();
    }
});

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
$('#googleFitDiv').on('tap', function(e) {
    e.preventDefault();
    goToPage("#googleFitPage");
}); 

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
$('#androidWearDiv').on('tap', function(e) {
    e.preventDefault();
    goToPage("#androidWearPage");
}); 
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
$('#soundSettingsDiv').on('tap', function(e) {
    e.preventDefault();
    if (soundStatus == 1) {
        goToPage("#soundSettingsPage");
    }
});

$('#rateUsLi').on('tap', function(e) {
    e.preventDefault();
    openPlayStore();
    // for GA
    var label = 'not set';
    if (window.noOfWorkOutsDone == -1) {
        // already done
        label = 'rating once more';
    } else {
        if (noOfWorkOutsDone < 5) {
            label = 'workoutsDone < 5';
        } else if (noOfWorkOutsDone >= 5 && noOfWorkOutsDone <= 15) {
            label = 'workoutsDone upto 15';
        } else if (noOfWorkOutsDone >= 15) {
            label = 'workoutsDone > 15';
        }
    }

    if (gaPlugin != null)
        gaPlugin.trackEvent('Rate Us', 'Review us li click', label);
});


$('#feedbackLi').on('tap', function(e) {

//    //open external contact/feedback page
//    var options = 'location=no,toolbarposition=top';
//    var ref = window.open('https://docs.google.com/forms/d/1kExOnabu2DlXN8rL84oKGvC2APMBwuvW7NgbEPVvVl0/viewform', '_blank', options);
//    ref.addEventListener("exit", function(){
//        if (gaPlugin != null)
//            gaPlugin.trackView('Preferences-1');
//    });

    window.sendFeedback(function(msg){
        log(msg);
    });


    if (gaPlugin != null)
        gaPlugin.trackEvent('Feedback', 'Feedback click');
});



$('#appInviteLi').on('tap', function(e) {
    e.preventDefault();
     if (devicereadyStatus) {
        //      window.plugins.socialsharing.share(msg, "iCountTimer");

        window.sendAppInvite(function(msg) {

            // for GA
            var label = 'not set';
            if (window.noOfWorkOutsDone == -1) {
                // already done
                label = 'workoutsDone > 21';
            } else {
                if (noOfWorkOutsDone < 5) {
                    label = 'workoutsDone < 5';
                } else if (noOfWorkOutsDone >= 5 && noOfWorkOutsDone <= 15) {
                    label = 'workoutsDone upto 15';
                } else if (noOfWorkOutsDone >= 15) {
                    label = 'workoutsDone > 15';
                }
            }

            if (gaPlugin != null)
                gaPlugin.trackEvent('Share', 'App Invite li click', label);

        });

    } else{
        console.log(msg);
    }
        
});


// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
$('#activeCaloriesDiv').on('tap', function(e) {
    e.preventDefault();
     goToPage("#activeCaloriesDetailsPage");
});
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
var showEnableDTransDivCount = 0;
$('#translationsLabel').on('tap', function(e) {
    e.preventDefault();
    showEnableDTransDivCount++;
    log("showEnableDTransDivCount = " + showEnableDTransDivCount);
    if(showEnableDTransDivCount == 5){
        log("Enabling showEnableDTransDivCount");
        showShowEnableDTransDiv();
    }
});

function showShowEnableDTransDiv(){
    var TAG = arguments.callee.name + "(): ";
    log(TAG);
    window.showEnableDTransDiv = true;
    window.localStorage.setItem("showEnableDTransDiv",window.showEnableDTransDiv);
    showTranslationDivs();
}
