cordova.define("com.phonegap.plugins.nativeFunctionCall.CustomNativeAccess", function(require, exports, module) {var exec = require('cordova/exec');

window.echo2 = function(str, callback) {
    exec(function(winParam) {}, function(error) {}, "CustomNativeAccess", "action", ["firstArgument", "secondArgument", 42, false]);
};
module.exports = echo2;

window.echo = function(str, callback) {
   exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "echo", [str]);
};
module.exports = echo;

window.callNativeFunction = function(str, callback) {
    exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "callNativeFunction", [str]);
};
module.exports = callNativeFunction;

window.setMenuView = function(str, callback) {
    exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "setMenuView", [str]);
};
module.exports = setMenuView;

window.getAsyncCalledStatus = function(str, callback) {
    exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "getAsyncCalledStatus", [str]);
};
module.exports = getAsyncCalledStatus;


window.getCheckLicenseCalledStatus = function(str, callback) {
   exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "getCheckLicenseCalledStatus", [str]);
};
module.exports = getCheckLicenseCalledStatus;


//Open TTS settings
window.openTTS = function(str, callback) {
   exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "openTTS", [str]);
};
module.exports = openTTS;



window.getAppNotLicensed = function(str, callback) {
   exec(callback, function(err) {
        callback(err);
    }, "CustomNativeAccess", "getAppNotLicensed", [str]);
};
module.exports = getAppNotLicensed;


//Audio focus functions
window.getAudioFocus = function(success, error,args) {
	   exec(success, error, "CustomNativeAccess", "getAudioFocus", [args]);
};
module.exports = getAudioFocus;
	
	
window.releaseAudioFocus = function(success, error, args) {
	   exec(success, error, "CustomNativeAccess", "releaseAudioFocus", [args]);
};
module.exports = releaseAudioFocus;	


window.registerBR = function(success, error,args) {
	   exec(success, error, "CustomNativeAccess", "registerBR", [args]);
};
module.exports = registerBR;


window.unregisterBR = function(success, error,args) {
	   exec(success, error, "CustomNativeAccess", "unregisterBR", [args]);
};
module.exports = unregisterBR;



//-------------------------------------------------------------------------
//Show preferred activity list
window.showPreferredActivityList = function(title,preferredActivityTypes,activityTypesDefaultJSON,positiveB,negativeB,success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "showPreferredActivityList", [title,preferredActivityTypes,activityTypesDefaultJSON,positiveB,negativeB]);
};
module.exports = showPreferredActivityList;
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
//Show Save Preset dialog
window.showSavePresetDialog = function(title, presetName,positiveButton, negativeButton, success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "showSavePresetDialog", [title, presetName, positiveButton, negativeButton]);
};
module.exports = showSavePresetDialog;



window.showConfirmDialog= function(title, message,positiveButton, negativeButton, success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "showConfirmDialog", [title, message, positiveButton, negativeButton]);
};
module.exports = showConfirmDialog;


//Show setActivityType dialog
window.showSetCurrentActivityTypeDialog = function(title, preferredActivityTypes,activityTypesDefaultJSON, success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "showSetCurrentActivityTypeDialog", [title, preferredActivityTypes,activityTypesDefaultJSON]);
};
module.exports = showSetCurrentActivityTypeDialog;
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------

//Build fitness Client
window.connectToFitnessClient = function(success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "connectToFitnessClient", []);
};
module.exports = connectToFitnessClient;



window.disableGoogleFit = function(success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "disableGoogleFit", []);
};
module.exports = disableGoogleFit;



window.getGoogleFitClientStatus = function(success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "getGoogleFitClientStatus", []);
};
module.exports = getGoogleFitClientStatus;



window.insertFitnessActivityData = function(doneWorkoutDetails,success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "insertFitnessActivityData", [doneWorkoutDetails]);
};
module.exports = insertFitnessActivityData;


window.deleteAppFitnessActivityData = function(success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "deleteAppFitnessActivityData", []);
};
module.exports = deleteAppFitnessActivityData;



window.restoreProVersion = function(success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "restoreProVersion", []);
};
module.exports = restoreProVersion;


//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
//Get estimated calories
window.getEstimatedCaloriesPlugin = function(workoutDetails, personalDetailsLocal,success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "getEstimatedCalories", [workoutDetails, personalDetailsLocal]);
};
module.exports = getEstimatedCaloriesPlugin;


window.getBMRPlugin = function(personalDetailsLocal,success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "getBMR", [personalDetailsLocal]);
};
module.exports = getBMRPlugin;


window.writePersonalDetailsToGoogleFitPlugin = function(personalDetailsLocal,success, error) {
                                   	   exec(success, error, "CustomNativeAccess", "writePersonalDetailsToGoogleFit", [personalDetailsLocal]);
};
module.exports = writePersonalDetailsToGoogleFitPlugin;
//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
//Send App Invite
window.sendAppInvite = function(success,error){
    exec(success,error,"CustomNativeAccess","sendAppInvite",[]);
};
module.exports = sendAppInvite;


//Update NativeDB
//Send App Invite
window.updateNativeDBPlugin = function(success,error){
    exec(success,error,"CustomNativeAccess","updateNativeDB",[]);
};
module.exports = updateNativeDBPlugin;

//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
//Send Bug Report
window.sendBugReport = function(success,error){
    exec(success,error,"CustomNativeAccess","sendBugReport",[]);
};
module.exports = sendBugReport;

//Send Feedback
window.sendFeedback = function(success,error){
    exec(success,error,"CustomNativeAccess","sendFeedback",[]);
};
module.exports = sendBugReport;


//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
// Disable TimeLeft circle?
window.isCanvasDisabled = function(success,error){
    exec(success,error,"CustomNativeAccess","isCanvasDisabled",[]);
};
module.exports = isCanvasDisabled;



//-------------------------------------------------------------------------
//-------------------------------------------------------------------------
// Disable/Enable Landscape mode
window.enableOrientationChange = function(flagChangeOrientation,success,error){
    exec(success,error,"CustomNativeAccess","enableOrientationChange",[flagChangeOrientation]);
};
module.exports = enableOrientationChange;

});
